/**
 * @package    Install from Bongovo! plugin
 *
 * @author     Pavel Poles - n3t.cz
 * @copyright  © 2022 Pavel Poles - n3t.cz. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link       https://n3t.bitbucket.io
**/

((window, document) => {
  window.bongovoInstall = (detailsUrl) => {
    // TODO zobrazit chybu
    var xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
      if (this.readyState === 4) {
        if (this.status === 200) {
          const json = JSON.parse(this.responseText);
          if (json.success) {
            console.log(json.data);
            var form = document.getElementById('adminForm');
            form.install_url.value = json.data;
            form.installtype.value = 'url';
            form.submit();
          } else {
            Joomla.renderMessages({error: [json.message]}, '#bongovo-message-container', false, 5000);
          }
        } else
          Joomla.renderMessages({error: [Joomla.Text._('PLG_INSTALLER_BONGOVO_ERROR_SERVER_REQUEST')]}, '#bongovo-message-container', false, 5000);
      }
    };

    xhttp.open('GET', 'index.php?option=com_ajax&plugin=bongovo&group=installer&format=json&url=' + detailsUrl, true);
    xhttp.send();
  };

  document.addEventListener('DOMContentLoaded', () => {
    document.querySelector('#bongovo-search').addEventListener('input', (event) => {
      for (const row of document.querySelectorAll('[data-bongovo-search]')) {
        row.classList.remove('hidden');
      }
      for (const body of document.querySelectorAll('#bongovo-table tbody')) {
        body.classList.remove('hidden');
      }
      document.querySelector('#bongovo-table .search-no-results').classList.add('hidden');
      if (event.target.value) {
        for (const row of document.querySelectorAll('[data-bongovo-search]:not([data-bongovo-search*="' + event.target.value.toLowerCase() + '"])')) {
          row.classList.add('hidden')
        }
        for (const body of document.querySelectorAll('#bongovo-table tbody')) {
          if (!body.querySelector('[data-bongovo-search]:not(.hidden)'))
            body.classList.add('hidden');
        }
        if (!document.querySelector('#bongovo-table tbody:not(.hidden)'))
          document.querySelector('#bongovo-table .search-no-results').classList.remove('hidden');
      }
    });
  });
})(window, document);